ed295eb9172a36a04973c8458da522565c2a4c47
[iankelling.org] / setup.sh
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
8
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
13
14 # You should have received a copy of the GNU General Public License
15 # along with this program. If not, see <http://www.gnu.org/licenses/>.
16
17
18 set -eE -o pipefail
19 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
20
21 usage() {
22 cat <<EOF
23 Usage: ${0##*/} [OPTIONS] [DOMAIN_NAME]
24 Setup dependencies, apache, and gitweb. Then call build.rb.
25
26 Default DOMAIN_NAME is iankelling.org. Domain is expected to resolve
27 so we can get a let's encrypt cert.
28
29 This script depends on a few other git repos of mine: distro-functions
30 and basic-https-conf.
31
32
33 -p PORT Apache port, default is 443.
34 -h|--help Print help and exit.
35
36 Note: Uses GNU getopt options parsing style
37 EOF
38 exit $1
39 }
40
41 ##### begin command line parsing ########
42
43 port=443
44 temp=$(getopt -l help, p:h "$@") || usage 1
45 eval set -- "$temp"
46 while true; do
47 case $1 in
48 -p) port=$2; shift 2 ;;
49 -h|--help) usage ;;
50 --) shift; break ;;
51 *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
52 esac
53 done
54
55 ##### end command line parsing ########
56
57 x="$(readlink -f "$BASH_SOURCE")"
58 script_dir=${x%/*}
59 cd $script_dir
60
61 domain=${1:-iankelling.org} # use argument for testing site
62 gitroot=/a/bin/githtml
63
64 if [[ $EUID != 0 ]]; then
65 s=sudo
66 fi
67
68 deb8=false
69 if grep -xFq 'VERSION_ID="8"' /etc/os-release; then
70 deb8=true
71 fi
72
73 shopt -s extglob
74
75 type -P a2enmod &>/dev/null || $s apt-get -y install apache2
76 type -P sqlite3 &>/dev/null || $s apt-get -y install sqlite3
77
78
79 pkgs=(
80 # build.rb dependencies
81 ruby-pygments.rb ruby-safe-yaml ruby-sass
82 # python pkgs used for o(n^2) voting blog entry
83 python-bcrypt python-passlib
84 # gitweb pkgs
85 gitweb highlight
86 )
87 if $deb8; then
88 pkgs+=(build-essential ruby-dev)
89 else
90 pkgs+=(ruby-redcarpet)
91 fi
92
93 $s apt-get -y install ${pkgs[@]}
94 if $deb8; then
95 sudo gem install redcarpet
96 fi
97 chmod og+x _site/on2vote/vote.py
98
99
100 # debian has the package gitweb, which seems to mainly
101 # have some example apache config, and a minimal gitweb config.
102 # I'll just use the config as example and not use the package.
103 # It's example apache config seems to say we can use cgi or cgid,
104 # and googling cgid it seems a newer faster alternative. I also
105 # depend on this in my o(n^2) python script.
106 $s a2enmod cgid
107
108
109 # additional settings from browsing https://git-scm.com/docs/gitweb.conf
110 $s dd of=/etc/gitweb.conf <<EOF
111 \$feature{'highlight'}{'default'} = [1];
112 # highlighting doesn't work on files without extension.
113 # I noticed in terminal "highlight file" won't do it (unknown file type)
114 # hightlight < file will do it, and it's online documentation
115 # suggests it reads shebang. Todo: file a bug for gitweb
116 # to make highlight read shebangs.
117 our \$projectroot = "$gitroot";
118 # not documented at https://git-scm.com/docs/gitweb.conf,
119 # but it's in the debian conf, so use it.
120 # directory to use for temp files.
121 our \$git_temp = "/tmp";
122 push @git_base_url_list, "https://$domain/git";
123 our @extra_breadcrumbs = (
124 [ '$domain' => '/' ],
125 );
126 our \$home_link_str = 'git';
127 our \$site_footer = '$PWD/_site/gitweb-footer.html';
128 push @stylesheets, "/css/gitweb-site.css";
129 our \$favicon = '/assets/favicon.png';
130 # default is 25, cuts off descriptions.
131 our \$projects_list_description_width = 50;
132 # a bit superflous since they are all me
133 our \$omit_owner = true;
134 # highlight scripts with no extension, uses a patch
135 # that is on it's way upstream.
136 our \$highlight_force = 1;
137 our \$home_text = "$script_dir/_site/gitweb_home.html";
138 our \$projects_list_group_categories = 1;
139 EOF
140
141 web-conf -p $port - apache2 $domain <<EOF
142 # to run python script on my site:
143 <Directory /var/www/$domain/html/on2vote>
144 # to run python scripts with cgi
145 Options +ExecCGI
146 AddHandler cgi-script .py
147 </Directory>
148
149 <Directory "/var/www/$domain/html/cgi">
150 Options +ExecCGI
151 SetHandler cgi-script
152 </Directory>
153
154 # redirect some old paths when I was using jekyll.
155 Redirect permanent /10-14-2014/On2-vote-results.html /blog/on2-vote-results.html
156 Redirect permanent /09-29-2014/say-On2.html /blog/say-on2.html
157 Redirect permanent /08-07-2014/uninstalling-setup.html /blog/python-uninstall.html
158 Redirect permanent /08-01-2014/publising-my-technical-notes.html /blog/publishing-my-technical-notes.html
159
160 # All below is for gitweb + git-http-web.
161 # A simple builtin way to have a read only git website.
162 # I didn't find any significantly better alternatives out there.
163 SetEnv GIT_PROJECT_ROOT $gitroot
164 SetEnv GIT_HTTP_EXPORT_ALL
165
166 # note: cgi scripts can go anywhere into the filesystem,
167 # so there is no need to do a directory block for $gitroot
168
169 # fot git-http-web
170 <Directory /usr/lib/git-core>
171 AllowOverride None
172 Require all granted
173 </Directory>
174
175 <Directory /usr/share/gitweb>
176 Options +FollowSymLinks +ExecCGI
177 AddHandler cgi-script .cgi
178 </Directory>
179
180 # from man-git-http-backend, so git-http-web ang gitweb can both be used.
181 # it is instead of this:
182 # #ScriptAlias / /usr/lib/git-core/git-http-backend/
183 ScriptAliasMatch \\
184 "(?x)^/git/(.*/(HEAD | \\
185 info/refs | \\
186 objects/(info/[^/]+ | \\
187 [0-9a-f]{2}/[0-9a-f]{38} | \\
188 pack/pack-[0-9a-f]{40}\\.(pack|idx)) | \\
189 git-(upload|receive)-pack))\$" \\
190 /usr/lib/git-core/git-http-backend/\$1
191
192
193
194 # man-git-http-backend claims we should do this, but
195 # it causes no css/images to be displayed. Instead,
196 # just stick with the standard gitweb example directive
197 # from debian.
198 #ScriptAlias /git /usr/share/gitweb/gitweb.cgi/
199 Alias /git /usr/share/gitweb
200 EOF
201
202
203
204 $script_dir/gitweb-descriptions $gitroot
205
206 $script_dir/build.rb
207 $s rm -rf /var/www/$domain/html
208 $s ln -sT $script_dir/_site /var/www/$domain/html